class Rebels::Fakes::FakeDB
  class NonNullFinder < Struct.new(:attrs)
    def to_proc
      ->(thing) { attrs.select{|k,v| !v.nil?}.all?{|k,v| thing.send(k) == v } }
    end
  end

  def initialize
    @tables = {}
    @ids = {}
  end

  def where(table, filters)
    @tables[table].select(&NonNullFinder.new(filters))
  end

  def insert(table, record)
    @tables[table] ||= []
    record = record.with(id: next_id(table))
    @tables[table] << record
    record
  end

  def update(table, id, attrs)
    record = @tables[table].detect{|r| r.id == id}
    idx = @tables[table].index(record)
    @tables[table][idx] = record.with(attrs)
    nil
  end

  private
  def next_id(table)
    @ids[table] ||= 0
    @ids[table] += 1
    @ids[table]
  end
end
