require 'values'
require 'active_support/core_ext/hash/indifferent_access'
require_relative './with'

class Rebels::Values::Request < Value.new(:method, :session, :params, :env, :path, :path_params)
  include Rebels::Values::With

  def path_params
    @path_params || {}
  end

  def params
    HashWithIndifferentAccess.new(@params)
  end

  def all_params
    path_params.merge(params)
  end

  def method
    @method || "GET"
  end

end
